#ifndef __IODIOCTL_H
#define __IODIOCTL_H

#include <winioctl.h>

#define FILE_DEVICE_IODRIVER	32768
#define IOCTL_IODRIVER_BASE FILE_DEVICE_IODRIVER

//#define IOCTL_IODRIVER_????        \
//    CTL_CODE(IOCTL_IODRIVER_BASE, 2048, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_IODRIVER_READ_IO        \
    CTL_CODE(IOCTL_IODRIVER_BASE, 2048, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_IODRIVER_WRITE_IO        \
    CTL_CODE(IOCTL_IODRIVER_BASE, 2049, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_IODRIVER_READ_BASEDEF        \
    CTL_CODE(IOCTL_IODRIVER_BASE, 2050, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_IODRIVER_READ_MODULE_STATUS        \
    CTL_CODE(IOCTL_IODRIVER_BASE, 2051, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_IODRIVER_LOCK_WRITES        \
    CTL_CODE(IOCTL_IODRIVER_BASE, 2052, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_IODRIVER_UNLOCK_WRITES        \
    CTL_CODE(IOCTL_IODRIVER_BASE, 2053, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_IODRIVER_INITIALIZED        \
    CTL_CODE(IOCTL_IODRIVER_BASE, 2054, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_IODRIVER_CONFIG_SCAN        \
    CTL_CODE(IOCTL_IODRIVER_BASE, 2055, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_IODRIVER_POLL_IO        \
    CTL_CODE(IOCTL_IODRIVER_BASE, 2056, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_IODRIVER_CLEAR_MODULE_STATUS        \
    CTL_CODE(IOCTL_IODRIVER_BASE, 2057, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_IODRIVER_INIT_BASEDEF        \
    CTL_CODE(IOCTL_IODRIVER_BASE, 2058, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_IODRIVER_READ_SHARED_RAM        \
    CTL_CODE(IOCTL_IODRIVER_BASE, 2059, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_IODRIVER_WRITE_SHARED_RAM        \
    CTL_CODE(IOCTL_IODRIVER_BASE, 2060, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_IODRIVER_GET_SCAN_COUNT        \
    CTL_CODE(IOCTL_IODRIVER_BASE, 2061, METHOD_BUFFERED, FILE_ANY_ACCESS)


//	return ReadIO(pDataBegin, pSizeofData, FALSE);

#ifdef __cplusplus
extern "C" {
#endif

#pragma pack(1)

typedef struct 
	{
	WORD Base;
	WORD Slot;
	WORD Address;
	WORD NumBytes;
	BYTE Data[256];
	} MemOp;

#pragma pack()

#ifdef __cplusplus
}
#endif
#endif // __IODIOCTL_H
