// MailDemo.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include <winplcrt.h>
#include "SMTP.h"

/*
** MailDemo
**
** This sample sends an email to the specified address. It demonstrates use of the CSMTP mail
** class. Use this as a basis for developing mail capablity for your WinPLC.
**
*/

#define SMTP_SERVER		"interserv"					// Your mail server here
#define SOURCE_ADDRESS	"winplc@hosteng.com"		// Your source address here
#define DEST_ADDRESS		"winplc@hosteng.com"		// Your destination address here
#define DEST_NAME			"MailDemo"					// You destination friendly name here

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	OutputDebugString(TEXT("MailDemo started!"));

	CSMTP smtp(TEXT(SMTP_SERVER));
	CMailMessage msg;
	msg.m_sFrom = TEXT(SOURCE_ADDRESS);
	msg.AddRecipient(TEXT(DEST_ADDRESS), TEXT(DEST_NAME));
	msg.m_sSubject = TEXT("MailDemo Sample");
	msg.m_sBody = TEXT("This email message was sent from the WinPLC");

	if(!smtp.Connect())
		{
		OutputDebugString(smtp.GetLastError());
		return -1;
		}
	
	if(!smtp.SendMessage(&msg))
		{
		OutputDebugString(smtp.GetLastError());
		return -1;
		}

	if(!smtp.Disconnect())
		{
		OutputDebugString(smtp.GetLastError());
		return -1;
		}
	
	OutputDebugString(TEXT("MailDemo exiting. Bye!"));
	return 0;
}

