// MailMessage.h: interface for the CMailMessage class.
// Copyright (c) 1998, Wes Clyburn
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAILMESSAGE_H__55DE48CC_BEA4_11D1_870E_444553540000__INCLUDED_)
#define AFX_MAILMESSAGE_H__55DE48CC_BEA4_11D1_870E_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

//#include <afxtempl.h>
#include "cstr.h"

class CMailMessage  
{
public:
	CMailMessage();
	virtual ~CMailMessage();

	int GetNumRecipients();
	BOOL GetRecipient( CStr& sEmailAddress, CStr& sFriendlyName, int nIndex = 0 );
	BOOL AddRecipient( LPCTSTR szEmailAddress, LPCTSTR szFriendlyName = L"" );
	BOOL AddMultipleRecipients( LPCTSTR szRecipients = NULL );

	CStr m_sFrom;
	CStr m_sSubject;
	CStr m_sHeader;
//	CTime m_tDateTime;	
	CStr m_sBody;
private:
	class CRecipient
	{
		public:
			CStr m_sEmailAddress;
			CStr m_sFriendlyName;
	};

//	CArray <CRecipient, CRecipient&> m_Recipients;
	CRecipient aRecipients[10];
	int RecCount;
};

#endif // !defined(AFX_MAILMESSAGE_H__55DE48CC_BEA4_11D1_870E_444553540000__INCLUDED_)
